## symbiosis-firewall 0717

=== debian/changelog ===
symbiosis-firewall (2018:0717) stable; urgency=medium

  * Fixed typo in pattern.rb to prevent erroneous cron emails.

 -- Andrew Ladlow <andrew.ladlow@bytemark.co.uk>  Tue, 17 Jul 2018 08:31:29 +0100

symbiosis-firewall (2017:0901) stable; urgency=medium

  * Removed default install of reject-www-data rule.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Fri, 01 Sep 2017 15:17:19 +0100

symbiosis-firewall (2017:0510) stable; urgency=medium

  * Store monit configuration in /usr/share instead of /etc. Use symlinks to
    allow users to enable/disable but discourage editing

 -- Telyn <telyn@bytemark.co.uk>  Wed, 10 May 2017 13:42:15 +0100

symbiosis-firewall (2017:0424) stable; urgency=medium

  * Updated monit scripts to work with systemd.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Mon, 24 Apr 2017 14:40:11 +0100

symbiosis-firewall (2015:1024) stable; urgency=medium

  * Ensure manpages are generated as part of the build task.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Thu, 06 Jul 2017 16:07:35 +0100

symbiosis-firewall (2015:1023) stable; urgency=medium

  * Updated code to work with the new version of symbiosis-common. 

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Thu, 14 Jan 2016 16:42:37 +0000

symbiosis-firewall (2015:1022) stable; urgency=medium

  * Make sure firewall rules for all addresses are applied properly.
  * Fixed two cases of overly verbose output, one from testing to see if the
    nat table exists, and the other parsing IP addresses.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Thu, 22 Oct 2015 16:57:36 +0100

symbiosis-firewall (2015:1009) stable; urgency=medium

  * Changed REJECT target to send back a tcp-reset packet for TCP connections.
  * Only flush nat table if it exists.
  * Rejigged DNS resolution code not to barf if DNS is unavailable.
  * Added basic SYN-ACK/ACK flood protection.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Fri, 09 Oct 2015 17:00:10 +0100

symbiosis-firewall (2015:0617) stable; urgency=medium

  * Changed File#exists? to File#exist? everywhere.
  * Added high numbered port range for passive FTP + TLS.
  * Now all tables (filter, nat, raw) are flushed.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Wed, 17 Jun 2015 10:22:48 +0100

symbiosis-firewall (2015:0128) stable; urgency=medium

  * Updated the Debian standards.

 -- Steve Kemp <steve@bytemark.co.uk>  Wed, 28 Jan 2015 09:55:09 +0000

symbiosis-firewall (2014:1111) stable; urgency=medium

  * Updated postinst not to use scripts with paths.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Fri, 07 Aug 2015 21:36:28 +0100

symbiosis-firewall (2014:1110) stable; urgency=medium

  * Make sure firewall patterns are anchored at one end.
  * Ignore .dpkg-* files in directories.
  * Sanitise log lines to prevent bad UTF causing problems.

 -- James Carter <jcarter@bytemark.co.uk>  Mon, 10 Nov 2014 10:57:26 +0000

symbiosis-firewall (2014:0313) stable; urgency=medium

  * Make sure the firewall load script has sbin in its path.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Thu, 13 Mar 2014 16:09:07 +0000

symbiosis-firewall (2014:0226) stable; urgency=low

  * Tidied up the postinstall for the better, I hope.
  * Removed preinst.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Wed, 26 Feb 2014 15:54:58 +0000

symbiosis-firewall (2014:0218) stable; urgency=low

  * Updated postinst to chown the firewall directory to admin:admin, rather
    than 1000:1000.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Tue, 18 Feb 2014 13:16:33 +0000

symbiosis-firewall (2014:0217) stable; urgency=low

  * Removed old lenny command symlinks.
  * Removed extra spaces from incron.d snippet.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Mon, 17 Feb 2014 11:58:29 +0000

symbiosis-firewall (2014:0214) stable; urgency=low

  * Removed DH_VERBOSE flag in rules.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Fri, 14 Feb 2014 13:11:04 +0000

symbiosis-firewall (2014:0211) stable; urgency=low

  * Removed comments in incron.d snippet.
  * Updated db libraries to fix warnings.
  * Empty hostnames/ports are now ignored.
  * Added more tests to IPDirectory class.
  * Accept service names in blacklist files.
  * Added bug control.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Tue, 11 Feb 2014 15:24:03 +0000

symbiosis-firewall (2014:0116) stable; urgency=low

  * Updated incrond to use /usr/bin/ruby
  * Fixed missing variable in symbiosis-firewall-whitelist.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Thu, 16 Jan 2014 16:39:12 +0000

symbiosis-firewall (2014:0113) stable; urgency=low

  * Updated dependencies.
  * Updateded maintainer and uploaders.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Mon, 13 Jan 2014 17:05:58 +0000

symbiosis-firewall (2013:0711) stable; urgency=low

  * Changing build tag + added ruby1.8 dependency.

 -- John Hackett <jhackett@maker.sh.bytemark.co.uk>  Thu, 11 Jul 2013 15:12:37 +0100

symbiosis-firewall (2013:0611) stable; urgency=low

  * Configure the firewall not to run duing ifup/down if the interface is the
    "lo" loopback interface.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Tue, 11 Jun 2013 16:34:16 +0100

symbiosis-firewall (2013:0610) oldstable; urgency=low

  * Fixed disabling white/blacklist functionality.
  * Changed blacklist to drop rather than reject connections.
  * Blacklist limits are now 100/24h or 25 since last run.

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Mon, 10 Jun 2013 14:31:48 +0100

symbiosis-firewall (2012:0418) oldstable; urgency=low

  * Symbiosis::Firewall::Template#to_s no longer tries to interpolate / strip
    $ variables in comment lines.
  * Fixed spelling error in symbiosis-firewall

 -- Patrick J Cherry <patrick@bytemark.co.uk>  Wed, 18 Apr 2012 15:40:15 +0100

symbiosis-firewall (2012:0308) stable; urgency=low

  * Updated reject-www-data rule to create its own chain, ensuring that the
    rule will work for multiple addresses.
  * Allow www-data to do DNS resolution.



=== debian/rules ===
#!/usr/bin/make -f
#
# export DH_VERBOSE=1
#
# Uncomment to ignore all test failures (but the tests will run anyway)
#export DH_RUBY_IGNORE_TESTS=all
#
#
# Uncomment to ignore some test failures (but the tests will run anyway).
# Valid values:
#export DH_RUBY_IGNORE_TESTS=ruby1.8 ruby1.9.1 require-rubygems
#
# If you need to specify the .gemspec (eg there is more than one)
#export DH_RUBY_GEMSPEC=gem.gemspec

%:
	dh $@ --buildsystem=ruby --with ruby

override_dh_auto_build:
	$(MAKE) all

override_dh_auto_clean:
	$(MAKE) clean

## symbiosis-firewall 0901

=== Makefile ===
#
#  Makefile for the firewall package
#

RUBYLIB := "$(PWD)/lib:$(PWD)/ext:$(PWD)/../common/lib"

nop:
	@echo "Makefile - available targets"
	@echo " "
	@echo " all       - generate rules and manpages"
	@echo " rules     - generate automatic rules"
	@echo " manpages  - generate manpages for ./bin/firewall"
	@echo " test      - test firewall installation"
	@echo " clean     - clean up"
	@echo " "

clean:
	if [ -d ./manpages ] ; then rm -rf ./manpages ; fi
	if [ -d ./i ] ; then rm -rf ./i ; fi
	cd ext && ruby extconf.rb
	make -C ext clean
	$(RM) ext/Makefile

manpages/%.man: ./sbin/%
	[ -d ./manpages ] || mkdir ./manpages
	RUBYLIB=$(RUBYLIB) $<  --manual | sed -e 's/^=\+$$//' | txt2man -s 1 -t $(notdir $<) | sed -e 's/\\\\fB/\\fB/' > $@
	test -s $@

manpages: ./manpages/symbiosis-firewall-whitelist.man ./manpages/symbiosis-firewall.man ./manpages/symbiosis-firewall-blacklist.man

all: manpages ext/symbiosis_utmp.so

distclean: clean

test: ext/symbiosis_utmp.so
	@cd test.d && RUBYLIB=$(RUBYLIB):. ruby ./ts_firewall.rb
	@if [ ! -d ./i ]; then mkdir ./i ; fi
	@if [ ! -d ./i/incoming.d/ ]; then mkdir ./i/incoming.d/; fi
	@if [ ! -d ./i/outgoing.d/ ]; then mkdir ./i/outgoing.d/; fi
	@if [ ! -d ./i/blacklist.d/ ]; then mkdir ./i/blacklist.d/; fi
	@if [ ! -d ./i/whitelist.d/ ]; then mkdir ./i/whitelist.d/; fi
	@if [ ! -d ./i/local.d/ ]; then mkdir ./i/local.d/; fi
	@touch  i/whitelist.d/192.168.1.100
	@touch  i/whitelist.d/2001:1af:123:00::1
	@touch  i/blacklist.d/192.168.1.101
	@touch  i/blacklist.d/2001:1af:123:00::2
	@touch  i/blacklist.d/.empty
	@touch  i/incoming.d/00-established
	@touch  i/incoming.d/00-related
	@touch  i/incoming.d/05-ping
	@touch  i/incoming.d/07-ssh
	@touch  i/incoming.d/09-this-template-should-not-be-used
	@touch  i/incoming.d/10-http
	@touch  i/incoming.d/15-https
	@touch  i/incoming.d/20-ftp
	@touch  i/incoming.d/30-imap
	@touch  i/incoming.d/40-imaps
	@touch  i/incoming.d/50-pop3
	@touch  i/incoming.d/60-pop3s
	@touch  i/incoming.d/70-smtp
	@touch  i/incoming.d/75-ntp
	@touch  i/incoming.d/80-smtps
	@touch  i/incoming.d/85-submission
	@touch  i/incoming.d/90-sieve
	@touch  i/incoming.d/99-reject
	@touch  i/outgoing.d/00-established
	@touch  i/outgoing.d/00-related
	@touch  i/outgoing.d/10-reject-www-data
	@echo "212.110.161.177" > i/outgoing.d/20-accept
	@echo "2001:41c8:20:862:ac1:1::|48" >> i/outgoing.d/20-accept
	@touch  i/outgoing.d/99-reject
	@RUBYLIB=$(RUBYLIB) ruby -I. ./sbin/symbiosis-firewall -p ./i -t rule.d -x -v -d

ext/symbiosis_utmp.so: ext/Makefile
	make -C ext $(notdir $@)

ext/Makefile: ext/extconf.rb
	cd ext/ && ruby $(notdir $<)

.PHONY: test manpages all clean distclean

=== debian/control ===
Source: symbiosis-firewall
Section: net
Priority: extra
Maintainer: James Carter <jcarter@bytemark.co.uk>
Uploaders: Patrick J Cherry <patrick@bytemark.co.uk>, Steve Kemp <steve@bytemark.co.uk>
Build-Depends: debhelper (>= 7.0.0), gem2deb, txt2man, ruby, ruby-dev
Standards-Version: 3.9.6
XS-Ruby-Versions: all

Package: symbiosis-firewall
Architecture: any
Depends: iptables, ruby, symbiosis-common (>= 2015:1210), libruby, ruby-sqlite3, incron, ${shlibs:Depends}, ${misc:Depends}
Replaces: bytemark-vhost-firewall, symbiosis-test, symbiosis-monit (<< 2011:1206)
Breaks: symbiosis-monit (<< 2011:1206)
Provides: bytemark-vhost-firewall
Conflicts: bytemark-vhost-firewall, symbiosis-test
Description: Symbiosis firewall generator
 This package contains a firewall generator which makes it simple to restrict
 the incoming and outgoing connections a machine is permitted to accept or
 initiate.
 .
 The firewall also allows the user to restrict the abilities of the
 www-data user  which will ensure that any PHP, or website, compromises
 do not propagate.
